/* X-Window ȯ濡 ѱ ÷̸  ڵ. ѱ Xlib ġ  .
   Copyright (C) 1994, 95, 96 ϴϸ  (fpf545@dosa1.snu.ac.kr).

   ***   ڵ带 Ϻ ̿Ͽϴ. ***

   Emacs ҽ ڵ忡 ѱ ó   κ hanemacs 
   ũθ ϰ ֽϴ.  κ   ȭϰ Բ 
   ϴϸ ҽ ڵ ֵ˴ϴ.

HanEmacs is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2, or (at your option)
any later version.

HanEmacs is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with GNU Emacs; see the file COPYING.  If not, write to
the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.  */

#include <X11/Xlib.h>
#include <config.h>
#include "hangul.h"

int han_johab_font;
int font_ks_mode = 't';

int
check_hangul_font (font)
     char *font;
{
  if (strstr (font, "johab"))
    han_johab_font = 1;
  else if (strstr (font, "JOHAB"))
    han_johab_font = 1;
  else if (strstr (font, "ksc5601.1987"))
    han_johab_font = 0;
  else if (strstr (font, "KSC5601.1987"))
    han_johab_font = 0;
  else
    error ("Hangul Font is not defined.\n");
  
  return han_johab_font;
}

/* ħ   ()     ʼ    */
static int fcon_map1[] = 
{
    0, 0,
    0, 0, 0, 0, 0, 0,		     /* (ä),,,,, */
    0, 0,
    0, 0, 0, 1, 3, 3,		     /* ,,,,Ǥ,Ǥ */
    0, 0,
    3, 1, 2, 4, 4, 4,		     /* Ǥ,,,̤,̤,̤ */
    0, 0,
    2, 1, 3, 0			     /* ,,Ѥ, */
};

/* ħ   ()     ʼ    */
static int fcon_map2[] = 
{
    0, 0,
    5, 5, 5, 5, 5, 5,		     /* (ä),,,,, */
    0, 0,
    5, 5, 5, 6, 8, 8,		     /* ,,,,Ǥ,Ǥ */
    0, 0,
    8, 6, 7, 9, 9, 9,		     /* Ǥ,,,̤,̤,̤ */
    0, 0,
    7, 6, 8, 5			     /* ,,Ѥ, */
};

/* ()   font index */
static int vow_base[] = 
{
    0, 0,
    0, 311, 314, 317, 320, 323,	     /* (ä),,,,, */
    0, 0,
    326, 329, 332, 335, 339, 343,    /* ,,,,Ǥ,Ǥ */
    0, 0,
    347, 351, 355, 358, 361, 364,    /* Ǥ,,,̤,̤,̤ */
    0, 0,
    367, 370, 374, 378		     /* ,,Ѥ, */
};

/* ()    ƴ  */
static int vow_kind[] = 
{
    0, 0,
    0, 0, 0, 0, 0, 0,		     /* (ä),,,,, */
    0, 0,
    0, 0, 0, 1, 1, 1,		     /* ,,,,Ǥ,Ǥ */
    0, 0,
    1, 1, 0, 0, 0, 0,		     /* Ǥ,,,̤,̤,̤ */
    0, 0,
    0, 1, 1, 0			     /* ,,Ѥ, */
};

/* (ħ)    翡  */
static int lcon_kind[] = 
{
    0, 0, 1, 1, 1, 2, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
    0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1
};

/* ()   ħ   */
static int lcon_map[] = 
{
    0, 0,
    0, 0, 2, 0, 2, 1,
    0, 0,
    2, 1, 2, 3, 0, 0,
    0, 0,
    0, 3, 3, 1, 1, 1,
    0, 0,
    3, 3, 0, 1
};

static int
convert_3_to_display (f, m, l, des)
     int f, m, l;
     XChar2b *des;
{
  int ind;
  int i = 0;
  
  if (f == 0xff) /* ׷ ڵ */
    {
      ind = (m - 0xa1) * 94 + l - 0xa1 + 0x211;
      des[i].byte1 = ind / 256;
      des[i].byte2 = ind % 256;
      return 1;
    }
  if (f < 1 || f > 20 || m < 2 || m > 29 || l < 1 || l > 29) 
    {
      des[i].byte1 = 0;	     /*  */
      des[i].byte2 = 0;
      return 1;
    }
  if (f != 1) /* ä ƴϸ ... */
    {
      ind = f * 10 + (l > 1 ? fcon_map2[m] : fcon_map1[m]) - 19;
      des[i].byte1 = ind >> 8;
      des[i].byte2 = ind;
      i++;
    }
  if (m != 2) /* ä ƴϸ ... */
    {
      ind = vow_base[m];
      switch (vow_kind[m]) 
	{
	case 0:			     /*  迭 ƴϸ ... */
	  ind += lcon_kind[l];
	  break;
	case 1:			     /* , Ǥ, Ǥ, ... 迭 */
	  ind += ((f == 2 || f == 17) ? 0 : 1) + (l > 1 ? 2 : 0);
	  /* , ϶ Ưó */
	  break;
	}
      des[i].byte1 = ind >> 8;
      des[i].byte2 = ind;
      i++;
    }
  if (l != 1) 
    {
      ind = l * 4 + lcon_map[m] + (l < 18 ? 397 : 393);
      /* l == 18 ϶ ƹħ ƴϱ⶧
	 Ư ó */
      des[i].byte1 = ind >> 8;
      des[i].byte2 = ind;
      i++;
    }
  if (f != 1 && m == 2 && l == 1) 
    {
      /* initial sound only? */
      des[i].byte1 = 0;	/* dummy for no zero width */
      des[i].byte2 = 0;
      i++;
    }
  
  return i;
}

/*  ڸ 3 Ʈ  ٲ۴. */
static int
convert_johab_to_3 (src, f, m, l)
     unsigned char *src;
     int *f, *m, *l;
{
  if (src[0] >= 0x84 && src[0] <= 0xd3)  /*  ѱ */
    {
      *f = (src[0] >> 2) & 0x1f;
      *m = ((src[0] << 3) | (src[1] >> 5)) & 0x1f;
      *l = src[1] & 0x1f;
    } 
  else /* Ư  */
    {
      *f = 0xff;
      if (src[0] >= 0xd9 && src[0] <= 0xde) 
	*m = (src[0] - 0xd9)*2 + 0xa1;
      
      else if (src[0] >= 0xe0 && src[0] <= 0xf9) 
	*m = (src[0] - 0xe0)*2 + 0xca;
      
      else if (src[0] == 0xd8) 
	*m = 0xc9;
      
      if (src[1] >= 0x31 && src[1] <= 0x7e) 
	*l = src[1] - 0x31 + 0xa1;
      
      else if (src[1] >= 0x91 && src[1] <= 0xa0) 
	*l = src[1] - 0x91 + (0x7f - 0x31) + 0xa1;
      
      else if (src[1] >= 0xa1 && src[1] <= 0xfe) 
	{
	  *l = src[1];
	  if (src[0] == 0xd8) 
	    *m = 0xfe;
	  else 
	    (*m)++;
	} 
      else 
	*l = 0;
    }
}

static int
convert_wstring_to_jstring (src, des, len)
     unsigned char *src, *des;
     int len;
{
  unsigned code;
  unsigned char *org;

  org = des;
  while (len > 0) 
    {
/*      code = convert_wc_to_jc (make_code_with_string (src));
      make_string_with_code (code, des); */
      convert_ws_to_js (src, des);
      src += 2;
      len -= 2;
      des += 2;
    }

  return (des - org);
}

static int
convert_jstring_to_wstring (src, des, len)
     unsigned char *src, *des;
     int len;
{
  unsigned code;
  unsigned char *org;

  org = des;
  while (len > 0) 
    {
/*      code = convert_jc_to_wc (make_code_with_string (src));
      make_string_with_code (code, des); */
      convert_js_to_ws (src, des);
      src += 2;
      len -= 2;
      des += 2;
    }

  return (des - org);
}

int
convert_hangul_to_display (src, des, len)
     unsigned char *src;
     XChar2b *des;
     int len;
{
  int n, f, m, l;
  XChar2b *org;
  unsigned char *buf;
  unsigned char tmp[2*MAX_XC2bBUF];

  /* wansung font */
  if (!han_johab_font)
    {
      if (!han_johab_mode)
	{
	  if (font_ks_mode == 't')
	    strcpy ((char *) des, src);
	  else
	    {
	      int i = len;
	      while (i > 0)
		{
		  des->byte1 = (*src++) - (unsigned char)0x80;
		  des->byte2 = (*src++) - (unsigned char)0x80;
		  des++;
		  i -= 2;
		}
	    }
	  return (len+1)/2;
	}
      else
	{
	  n = convert_jstring_to_wstring (src, des, len);

	  if (font_ks_mode != 't')
	    {
	      int i = n;
	      XChar2b *ptr = des;

	      while (i > 0)
		{
		  ptr->byte1 = ptr->byte1 - (unsigned char) 0x80;
		  ptr->byte2 = ptr->byte2 - (unsigned char) 0x80;
		  ptr++;
		  i -= 2;
		}
	    }

	  return (n+1)/2;
	}
    }

  /* johab font */
  if (han_johab_mode)
    buf = src;
  else
    {
      buf = tmp;
      n = convert_wstring_to_jstring (src, buf, len);
    }

  org = des;
  while (len > 0) 
    {
      convert_johab_to_3 (buf, &f, &m, &l);
      n = convert_3_to_display (f, m, l, des);
      buf += 2;
      len -= 2;
      des += n;
    }
  
  return (des - org);
}

